<ComClass(InteropDemo_VBClass.ClassId, InteropDemo_VBClass.InterfaceId, InteropDemo_VBClass.EventsId)> _
Public Class InteropDemo_VBClass

#Region "COM GUIDs"
    ' These  GUIDs provide the COM identity for this class 
    ' and its COM interfaces. If you change them, existing 
    ' clients will no longer be able to access the class.
    Public Const ClassId As String = "5d2b6cd3-7e06-4ccb-8aa4-60f37db710d5"
    Public Const InterfaceId As String = "026e7a9f-ec3f-4ffc-affc-378df92ac159"
    Public Const EventsId As String = "3a6fb25d-d995-4281-b014-bc8a5694769b"
#End Region

    ' A creatable COM class must have a Public Sub New() 
    ' with no parameters, otherwise, the class will not be 
    ' registered in the COM registry and cannot be created 
    ' via CreateObject.
    Public Sub New()
        MyBase.New()
    End Sub
    Public Function MyVBAvg(ByVal pELObj As TSKITLib.IEasyLanguageObject, _
        ByVal iAvgLength As Integer, ByVal szELVarName As String) As Integer
        Dim dMovAvg As Double = 0
        If pELObj.CloseMD(TSKITLib.EN_DATA_STREAM.dataDefault).BarsBack > iAvgLength And iAvgLength > 0 Then
            Dim dSum As Double = 0.0
            For i As Integer = 0 To (iAvgLength - 1)
                dSum = dSum + pELObj.CloseMD(TSKITLib.EN_DATA_STREAM.dataDefault).AsDouble(i)
            Next
            dMovAvg = dSum / iAvgLength
            pELObj.Variables(szELVarName).AsDouble = dMovAvg
            Return 1
        Else
            Return 0
        End If
    End Function
End Class


